# How to contribute
If you're interested, contributors are welcome!
  
As a frontend developer, I looked for a solution like this many times, but anything worked really well. So I decided to write my own JS function.
You can use this library and help make this better!
  
If you can help in any way - coding, writing documentation or correcting my basic English - fork this repo and create a pull request!

## Getting started
I usually use yarn. You can install `serve` with ```yarn install``` and try the example web page by typing: ```yarn start```.
For testing or development, you can use that example page.

In the `src/` folder you can find the source code, which is written in ES6 and compiled with babel. To build it, run `yarn build`, alternatively you can run `yarn watch` to keep babel running and automatically compiling your changes to the source code.
  
If you're interested in contributing, you can start with open issues or testing and reviewing code and documentation.

## Code style / project preferences
To have a unique code style across the whole library, even if it's a tiny one, the following common options must be used in any piece of code:
- Indenting with 2 spaces
- Avoid useless comments (use them only if strictly needed)
- We use `yarn` instead of `npm`
- We use semantic versioning for releases (see http://semver.org/)
  
We have configured `prettier` to achive that consistency, and it's a precommit hook.
